
/**
 * Get the relevant IDs of bookmarks with limits and offsets.
 */

var ObjectID = require('mongodb').ObjectID

var redis = require('../databases/redis')

exports.bookmarkers = function* (options) {
  var thing = options.thing
  var type = options.type
  var limit = options.limit || 25
  var offset = options.offset || 0
  var key = 'bookmarkee:' + type + ':' + thing._id.toHexString()
  var ids = yield redis.zrevrange(key, offset, offset + limit - 1)
  return ids.map(toID)
}

exports.bookmarks = function* (options) {
  var user = options.user
  var collection = options.collection
  var type = options.type
  var limit = options.limit || 25
  var offset = options.offset || 0
  var key = 'bookmark:' + type + ':' + collection + ':' + user._id.toHexString()
  var ids = yield redis.zrevrange(key, offset, offset + limit - 1)
  return ids.map(toID)
}

function toID(x) {
  return new ObjectID(x)
}
