
/**
 * Get all the mutual bookmarkers for a thing.
 */

var ObjectID = require('mongodb').ObjectID

var redis = require('../databases/redis')

module.exports = function* (user, thing, type) {
  var user_id = user._id.toHexString()
  var thing_id = thing._id.toHexString()
  var bookmarker_key = 'bookmarker:' + type + ':' + thing.collection + ':' + user_id
  var bookmarkee_key = 'bookmarkee:' + type + ':' + thing_id
  var out = 'mutual:bookmarkers:' + type + ':' + user_id + ':' + thing_id

  // union thing's followers and user's following
  var count = yield redis.zunionstore(out, 2, bookmarker_key, bookmarkee_key)
  if (!count) {
    yield redis.del(out)
    return []
  }

  var ids = yield redis.zrange(out, 0, -1)
  yield redis.del(out)
  return ids.map(toOID)
}

function toOID(x) {
  return new ObjectID(x)
}
