
var assert = require('http-assert')

var mdb = require('../databases/mongodb')
var Comment = require('./comment')

module.exports = function* (obj) {
  var comment = new Comment()

  Comment.set.relation(comment, 'creator', obj.creator)

  var parent = obj.parent
  Comment.set.relation(comment, 'parent', parent)

  if (parent.collection === 'comments') {
    assert(parent.id.ancestors)
    assert(parent.root)

    comment.id.ancestors = parent.id.ancestors.slice()
    comment.root = parent.root
  } else {
    comment.id.ancestors = []
    Comment.set.relation('root', parent)
  }

  comment.count.comment.ancestors = comment.id.ancestors.push(parent._id)

  yield Comment.set.markdown(comment, obj.markdown)

  return yield mdb.comments.insert(comment)
}
