
var DB = require('mongodb-next')

var config = require('../../config')

var db = module.exports = new DB(config.MONGO_URI, {
  w: 'majority',
  readPreference: 'nearest'
})

db.then(function () {
  ;[
    'bookmarks',
    'comments',
    'discussions',
    'messages',
    'motions',
    'notifications',
    'opinions',
    'pages',
    'reports',
    'tags',
    'votes',
  ].forEach(function (collection ) {
    require('../' + collection).collection = db.collection('bookmarks')
  })

  // this should NOT be necessary, but we need raw collections for mkue
  require('../votes/jobs').collection = db.raw.collection('votes.jobs')
}).catch(function (err) {
  console.error(err.stack)
  process.exit(1)
})
