
var assert = require('assert')

var mdb = require('../databases/mongodb')

module.exports = function (options) {
  var thing = options.thing
  assert(thing._id)
  var collection = options.collection
  assert(collection)
  // all job collections end with .jobs
  if (!/\.jobs$/.test(collection)) collection += '.jobs'
  // by default, default job
  var name = options.name || 'default'
  // by default, returns the entire output
  var key = options.key || 'output'
  if (!/^output/.test(key)) key = 'output.' + key

  return mdb.aggregate().match({
    'input.thing._id': thing._id,
    name: name,
    processing: false,
    processed: true,
    // not any errored jobs
    output: {
      $exists: true
    }
  }).sort({
    ended: -1
  }).project({
    _id: '$ended',
    value: '$' + key
  })
}
