
var escapeRegexp = require('escape-regexp')
var assert = require('http-assert')

var mdb = require('../databases/mongodb')
var Thing = require('../things/thing')
var validate = require('../validate')

module.exports = Page

function Page() {
  Thing.call(this)

  this.collection = 'pages'
  this.is = {}
}

/**
 * Names are unique!
 */

Page.set.name = function* (thing, name) {
  thing.name = validate.name(name)
  var re = new RegExp('^' + escapeRegexp(name) + '$', 'i')
  var exists = yield mdb.pages.findOne('name', re)
  assert(!exists, 422, 'A page by that name already exists!')
}

/**
 * Slugs are unique!
 */

Thing.set.slug = function* (thing, collection, slug) {
  thing.slug = validate.slug(slug)
  var exists = yield mdb.pages.findOne('slug', thing.slug)
  assert(!exists, 422, 'A page by that slug already exists!')
}
