
var assert = require('http-assert')

var mdb = require('../databases/mongodb')
var redis = require('../databases/redis')

module.exports = function* (thing, closer) {
  assert(closer, 401)
  assert(closer._id)
  assert(thing._id)

  // close all the reports in mongodb
  var a = mdb.reports.find({
    deleted: false,
    closed: false,
    'thing._id': thing._id
  }).set({
    closed: true,
    'date.closed': new Date(),
    'closer._id': closer._id
  })

  // remove the thing from the reports set
  var b = redis.zrem('reports', thing.collection + ':' + thing._id.toHexString())

  yield [a, b]
}
