
/**
 * Returns a tag if found.
 * Otherwise creates one.
 * Automatically approves a tag on creation.
 */

var mdb = require('../databases/mongodb')

var vote = require('../votes/create')

module.exports = function* (options) {
  var parent = options.parent
  var child = options.child
  var type = options.type

  var tag = yield mdb.tags.findOne({
    'parent._id': parent._id,
    'child._id': child._id,
    type: type,
  }).upsert({
    $setOnInsert: {
      collection: 'tags',
      'parent.collection': parent.collection,
      'child.collection': child.collection,
      'date.created': new Date()
    }
  }).new()

  yield vote({
    user: options.user,
    thing: tag,
    type: 'approve',
    value: 'approve',
  })

  return tag
}
