
/**
 * Manipulate the password.
 */

var pswd = require('pswd')

var mdb = require('../databases/mongodb')
var validate = require('../validator')

exports.create = function (password) {
  validate.password(password)
  return pswd.hash(password)
}

exports.check = function (user, password) {
  validate.password(password)
  return pswd.compare(password, user.password)
}

exports.update = function* (user, password) {
  password = yield exports.create(password)
  return yield mdb.users.findOne('_id', user._id)
    .set('password', password)
    .unset('reset')
    .new()
}

exports.remove = function (user) {
  return mdb.users.findOne('_id', user._id)
    .unset('password')
}
