
var assert = require('http-assert')

var mdb = require('../databases/mongodb')
var validate = require('../validate')
var password = require('./password')
var Page = require('../pages/page')

module.exports = User

function User() {
  Page.call(this)

  this.is.user = true
}

Page.extend(User)

User.set.email = function* (user, email) {
  email = validate.email(email)
  var exists = yield mdb.pages.findOne('email', email)
  assert(!exists, '422', 'User with that email address already exists!')
  user.email = email
}

User.set.password = function* (user, pswd) {
  validate.password(pswd)
  user.password = yield password.create(pswd)
}
