
var assert = require('assert')
var Queue = require('mkue')
var co = require('co')

var values = require('./values.json')

var queue = exports.queue = new Queue()

exports.run = function () {
  queue.define('change-weight', co.wrap(require('./change-weight')))
  queue.define('tally', co.wrap(require('./tally')))
  queue.ensureIndexes()
  queue.concurrency(5)
  queue.run()
}

exports.tally = function (options) {
  var thing = options.thing
  var type = options.type
  assert(values[type])

  queue.dispatch('tally', {
    thing: {
      _id: thing._id,
      collection: thing.collection,
    },
    type: options.type
  })
}

exports.changeWeight = function (user, weight) {
  assert(typeof weight === 'number')
  assert(weight > 0)

  queue.dispatch('change-weight', {
    user_id: user._id,
    weight: weight
  })
}
