
/**
 * After votes are tallied, update stuff.
 */

var co = require('co')

var mdb = require('../databases/mongodb')
var syndicate = require('../syndicate')
var onerror = require('../onerror')

syndicate.on('tally', function (options, votes) {
  update(options, votes).catch(onerror)
})

var update = module.exports = co.wrap(function* (options, votes) {
  var thing = options.thing
  var type = options.type

  var promises = []

  // set the votes on the thing
  promises.push(mdb[thing.collection].findOne({
    _id: thing._id
  }).set('votes.' + type, votes))

  yield promises
})
